public class Arbre{
    private int     info;
    private char    op;
    private Arbre   fg, fd, pere;
    private boolean empile;

    public Arbre(int value){
        info = value;
    }
    public Arbre(char c, Arbre ag, Arbre ad){
        op = c;
	fg = ag;
	fd = ad;
	fg.setPere(this);
	fd.setPere(this);
    }

    public final int     getInfo()           {return info;}
    public final char    getOp()             {return op;}
    public final boolean getEmpile()         {return empile;}
    public final void    setPere(Arbre arbre){pere = arbre;}
    public final void    setEmpile(boolean b){empile = b;}

    public final void parcoursIteratif(){
	Arbre courant = this;
	boolean fini = false;
	while (fini == false) {
	    while ((courant.fg != null) & (courant.fd != null)){
		visiterNoeudPrefixe(courant);
		courant.setEmpile(true);
		courant = courant.fg;
	    }
	    visiterFeuille(courant);
	    courant = courant.pere;
	    while ((courant.getEmpile()==false) &&  (courant.pere != null)) {
		visiterNoeudPostfixe(courant);
		courant = courant.pere;
	    }
	    if (courant.getEmpile()==true) {
		courant.setEmpile(false);
		visiterNoeudInfixe(courant);
		courant = courant.fd;
	    }
	    else {
		visiterNoeudPostfixe(courant);
		fini = true;
	    }
	}
    }

    public void visiterFeuille      (Arbre arbre){}
    public void visiterNoeudPrefixe (Arbre arbre){}
    public void visiterNoeudInfixe  (Arbre arbre){}
    public void visiterNoeudPostfixe(Arbre arbre){}
}
